local Keys = {
	["ESC"] = 322, ["F1"] = 288, ["F2"] = 289, ["F3"] = 170, ["F5"] = 166, ["F6"] = 167, ["F7"] = 168, ["F8"] = 169, ["F9"] = 56, ["F10"] = 57,
	["~"] = 243, ["1"] = 157, ["2"] = 158, ["3"] = 160, ["4"] = 164, ["5"] = 165, ["6"] = 159, ["7"] = 161, ["8"] = 162, ["9"] = 163, ["-"] = 84, ["="] = 83, ["BACKSPACE"] = 177,
	["TAB"] = 37, ["Q"] = 44, ["W"] = 32, ["E"] = 38, ["R"] = 45, ["T"] = 245, ["Y"] = 246, ["U"] = 303, ["P"] = 199, ["["] = 39, ["]"] = 40, ["ENTER"] = 18,
	["CAPS"] = 137, ["A"] = 34, ["S"] = 8, ["D"] = 9, ["F"] = 23, ["G"] = 47, ["H"] = 74, ["K"] = 311, ["L"] = 182,
	["LEFTSHIFT"] = 21, ["Z"] = 20, ["X"] = 73, ["C"] = 26, ["V"] = 0, ["B"] = 29, ["N"] = 249, ["M"] = 244, [","] = 82, ["."] = 81,
	["LEFTCTRL"] = 36, ["LEFTALT"] = 19, ["SPACE"] = 22, ["RIGHTCTRL"] = 70,
	["HOME"] = 213, ["PAGEUP"] = 10, ["PAGEDOWN"] = 11, ["DELETE"] = 178,
	["LEFT"] = 174, ["RIGHT"] = 175, ["TOP"] = 27, ["DOWN"] = 173,
	["NENTER"] = 201, ["N4"] = 108, ["N5"] = 60, ["N6"] = 107, ["N+"] = 96, ["N-"] = 97, ["N7"] = 117, ["N8"] = 61, ["N9"] = 118
}

----------------------------------------------------------------------------------------------------
-- Variables
----------------------------------------------------------------------------------------------------

local ESX 					= nil
local PlayerData			= {}
local OwnPlayerData 		= nil
local DependenciesLoaded 	= false

local Impound 				= Config.Impound

local GuiEnabled 			= false

local VehicleAndOwner 		= nil

local ImpoundedVehicles 	= nil

----------------------------------------------------------------------------------------------------
-- Setup & Initialization
----------------------------------------------------------------------------------------------------

Citizen.CreateThread(function()
	while ESX == nil do
		TriggerEvent('esx:getSharedObject', function(obj) ESX = obj end)
		Citizen.Wait(0)
	end
	
	while ESX.GetPlayerData().job == nil do
		Citizen.Wait(10)
	end
	DependenciesLoaded = true
	PlayerData = ESX.GetPlayerData()
end)


local Blips = {
	{ name = _U('impound'), color = 38, id = 380, x = 872.07, y = -1350.49, z = 26.30, scale = 1.5},
	{ name = _U('pound_out'), color = 3, id = 430, x = 826.30, y = -1290.20, z = 28.60, scale = 1.5},
	
	{ name = _U('parking_uninpound'), 	color = 38, id = 267, x = 818.01, y = -1334.19, z = 26.10, scale = 0.5},
	{ name = _U('parking_uninpound'),	color = 38, id = 267, x = 818.17, y = -1341.39, z = 26.10, scale = 0.5},
	{ name = _U('parking_uninpound'), 	color = 38, id = 267, x = 818.19, y = -1348.67, z = 26.10, scale = 0.5},
	{ name = _U('parking_uninpound'), 	color = 38, id = 267, x = 818.09, y = -1355.83, z = 26.10, scale = 0.5},
	{ name = _U('parking_uninpound'), 	color = 38, id = 267, x = 817.71, y = -1363.25, z = 26.10, scale = 0.5},
}

Citizen.CreateThread(function()
	for _, item in pairs(Blips) do
		item.blip = AddBlipForCoord(item.x, item.y, item.z)
		SetBlipSprite(item.blip, item.id)
		SetBlipColour (item.blip, item.color)
		SetBlipAsShortRange(item.blip, true)
		SetBlipScale(item.blip, item.scale)
		BeginTextCommandSetBlipName("STRING")
		AddTextComponentString(item.name)
		EndTextCommandSetBlipName(item.blip)
	end
end)

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(0)
		for k,v in pairs(Config.Zones) do
			DrawMarker(v.Type, v.Pos.x, v.Pos.y, v.Pos.z, 0.0, 0.0, 0.0, 0, 0.0, 0.0, v.Size.x, v.Size.y, v.Size.z, v.Color.r, v.Color.g, v.Color.b, 100, false, true, 2, false, false, false, false)
			DrawMarker(v.Type2, v.Pos.x, v.Pos.y, v.Pos.z, 0.0, 0.0, 0.0, 0, 0.0, 0.0, v.Size.x, v.Size.y, v.Size.z, v.Color2.r, v.Color2.g, v.Color2.b, 100, false, true, 2, false, false, false, false)
		end
	end
end)

----------------------------------------------------------------------------------------------------
-- Helper functions
----------------------------------------------------------------------------------------------------

function ShowHelpNotification(text)
	ClearAllHelpMessages()
	SetTextComponentFormat("STRING")
	AddTextComponentString(text)
	DisplayHelpTextFromStringLabel(0, false, true, 5000)
end

RegisterNetEvent('HRP:ESX:SetCharacter')
AddEventHandler('HRP:ESX:SetCharacter', function (playerData)
	OwnPlayerData = playerData
end)

RegisterNetEvent('HRP:ESX:SetVehicleAndOwner')
AddEventHandler('HRP:ESX:SetVehicleAndOwner', function (vehicleAndOwner)
	VehicleAndOwner = vehicleAndOwner
end)

RegisterNetEvent('HRP:Impound:SetImpoundedVehicles')
AddEventHandler('HRP:Impound:SetImpoundedVehicles', function (impoundedVehicles)
	ImpoundedVehicles = impoundedVehicles
end)

RegisterNetEvent('HRP:Impound:VehicleUnimpounded')
AddEventHandler('HRP:Impound:VehicleUnimpounded', function (data, index)
	local spawnLocationIndex = index % 3 + 1
	local localVehicle = json.decode(data.vehicle)
	-- print(localVehicle.health)
	ESX.Game.SpawnVehicle(localVehicle.model, Impound.SpawnLocations[spawnLocationIndex],
	Impound.SpawnLocations[spawnLocationIndex].h, function (spawnedVehicle)
		ESX.Game.SetVehicleProperties(spawnedVehicle, localVehicle)
		
		SetVehicleEngineHealth(spawnedVehicle, localVehicle.engineHealth)
		SetVehicleBodyHealth(spawnedVehicle, localVehicle.bodyHealth)
		SetVehicleFuelLevel(spawnedVehicle, localVehicle.fuelLevel)
		SetVehiclePetrolTankHealth(spawnedVehicle, localVehicle.petrolTankHealth)
		SetVehicleOilLevel(spawnedVehicle, localVehicle.oilLevel)
		SetVehicleDirtLevel(spawnedVehicle, localVehicle.dirtLevel)
		
		for windowIndex = 1, 13, 1 do
			-- Citizen.Trace("Smashing window! ")
			if(localVehicle.windows[windowIndex] == false) then
				SmashVehicleWindow(spawnedVehicle, windowIndex)
			end
		end
		
		for tyreIndex = 1, 7, 1 do
			-- Citizen.Trace("Pooppiiiin! ")
			if(localVehicle.tyresburst[tyreIndex] ~= false) then
				SetVehicleTyreBurst(spawnedVehicle, tyreIndex, true, 1000)
			end
		end
		
	end)
	ESX.ShowNotification("Your vehicle with the plate: " .. data.plate .. " has been unimpounded!")
	SetNewWaypoint(Impound.SpawnLocations[spawnLocationIndex].x, Impound.SpawnLocations[spawnLocationIndex].y)
end)

RegisterNetEvent('HRP:Impound:CannotUnimpound')
AddEventHandler('HRP:Impound:CannotUnimpound', function ()
	ESX.ShowNotification(_U('unimpound_no_cash'))
end)

----------------------------------------------------------------------------------------------------
-- NUI bs
----------------------------------------------------------------------------------------------------

function ShowImpoundMenu (action)
	
	local pos = GetEntityCoords(GetPlayerPed(PlayerId()))
	local vehicle = GetClosestVehicle(pos.x, pos.y, pos.z, 5.0, 0, 71)
	
	if (IsPedInAnyVehicle(GetPlayerPed(PlayerId()))) then
		ESX.ShowNotification(_U('leave_vehicle'))
		return
	end
	
	
	if (vehicle ~= nil) then
		local v = ESX.Game.GetVehicleProperties(vehicle)
		local data = {}
		
		TriggerServerEvent('HRP:ESX:GetCharacter', PlayerData.identifier)
		TriggerServerEvent('HRP:ESX:GetVehicleAndOwner', v.plate)
		Citizen.Wait(500)
		
		if (Config.NoPlateColumn == true) then
			Citizen.Wait(Config.WaitTime)
		end
		
		if(VehicleAndOwner == nil) then
			ESX.ShowNotification(_U('unknow_owner'))
			ESX.Game.DeleteVehicle(vehicle)
			return
		end
		
		data.action = "open"
		data.form 	= "impound"
		data.rules = Config.Rules
		data.vehicle = {
			plate = VehicleAndOwner.plate,
			owner = VehicleAndOwner.firstname .. ' ' .. VehicleAndOwner.lastname
		}
		
		if (PlayerData.job.name == 'police') then
			data.officer = OwnPlayerData.firstname .. ' ' .. OwnPlayerData.lastname
			GuiEnabled = true
			SetNuiFocus(true, true)
			SendNuiMessage(json.encode(data))
		end
		
		if (PlayerData.job.name == 'mecano') then
			data.mechanic = OwnPlayerData.firstname .. ' ' .. OwnPlayerData.lastname
			GuiEnabled = true
			SetNuiFocus(true, true)
			SendNuiMessage(json.encode(data))
		end
	else
		ESX.ShowNotification(_U('vehicle_nearby'))
	end
	
end

function ShowAdminTerminal ()
	PlayerData = ESX.GetPlayerData()
	GuiEnabled = true
	
	TriggerServerEvent('HRP:Impound:GetVehicles')
	Citizen.Wait(500)
	
	SetNuiFocus(true, true)
	local data = {
		action = "open",
		form = "admin",
		user = OwnPlayerData,
		job = PlayerData.job,
		vehicles = ImpoundedVehicles
	}
	
	SendNuiMessage(json.encode(data))
end

function DisableImpoundMenu ()
	GuiEnabled = false
	SetNuiFocus(false)
	SendNuiMessage("{\"action\": \"close\", \"form\": \"none\"}")
	OwnPlayerData = nil
	VehicleAndOwner = nil
	ImpoundedVehicles = nil
end

function ShowRetrievalMenu ()
	
	PlayerData = ESX.GetPlayerData()
	
	TriggerServerEvent('HRP:ESX:GetCharacter', PlayerData.identifier)
	TriggerServerEvent('HRP:Impound:GetImpoundedVehicles', PlayerData.identifier)
	Citizen.Wait(500)
	
	GuiEnabled = true
	SetNuiFocus(true, true)
	local data = {
		action = "open",
		form = "retrieve",
		user = OwnPlayerData,
		job = PlayerData.job,
		vehicles = ImpoundedVehicles
	}
	
	SendNuiMessage(json.encode(data))
end

RegisterNUICallback('escape', function(data, cb)
	DisableImpoundMenu()
	
	-- cb('ok')
end)



RegisterNUICallback('impound', function(data, cb)

	local playerPed = PlayerPedId()
	local coords    = GetEntityCoords(playerPed)

	local v = GetClosestVehicle(coords.x, coords.y, coords.z, 5.0, 0, 71)
	-- print(v)

	local veh = ESX.Game.GetVehicleProperties(v)
	-- print(veh)

	
	veh.engineHealth = GetVehicleEngineHealth(v)
	veh.bodyHealth = GetVehicleBodyHealth(v)
	veh.fuelLevel = GetVehicleFuelLevel(v)
	veh.oilLevel = GetVehicleOilLevel(v)
	veh.petrolTankHealth = GetVehiclePetrolTankHealth(v)
	veh.tyresburst = {}
	for i = 1, 7 do
		res = IsVehicleTyreBurst(v, i, false)
		if res ~= nil then
			veh.tyresburst[#veh.tyresburst+1] = res
			if res == false then
				res = IsVehicleTyreBurst(v, i, true)
				veh.tyresburst[#veh.tyresburst] = res
			end
		else
			veh.tyresburst[#veh.tyresburst+1] = false
		end
	end
	
	veh.windows = {}
	for i = 1, 13 do
		res = IsVehicleWindowIntact(v, i)
		if res ~= nil then
			veh.windows[#veh.windows+1] = res
		else
			veh.windows[#veh.windows+1] = true
		end
	end
	
	if (veh.plate:gsub("%s+", "") ~= data.plate:gsub("%s+", "")) then
		ESX.ShowNotification(_U('vehicle_plate_error'))
		return
	end
	
	data.vehicle = veh;
	data.identifier = VehicleAndOwner.identifier;
	
	TriggerServerEvent('HRP:Impound:ImpoundVehicle', data)
	
	ESX.Game.DeleteVehicle(ESX.Game.GetClosestVehicle())
	
	DisableImpoundMenu()
	-- cb('ok')
end)

RegisterNUICallback('unimpound', function(plate, cb)
	Citizen.Trace("Unimpounding:" .. plate)
	TriggerServerEvent('HRP:Impound:UnimpoundVehicle', plate)
	DisableImpoundMenu()
	-- cb('ok')
end)

RegisterNUICallback('unlock', function(plate, cb)
	TriggerServerEvent('HRP:Impound:UnlockVehicle', plate)
end)
----------------------------------------------------------------------------------------------------
-- Background tasks
----------------------------------------------------------------------------------------------------

-- Decide what the player is currently doing and showing a help notification.
Citizen.CreateThread(function ()
	
	while true do
		inZone = false
		Citizen.Wait(500)
		if (DependenciesLoaded) then
			local PlayerPed = GetPlayerPed(PlayerId())
			local PlayerPedCoords = GetEntityCoords(PlayerPed)
			
			local coords    = GetEntityCoords(PlayerPed)

			local closestVehicle = GetClosestVehicle(coords.x, coords.y, coords.z, 5.0, 0, 71)

			if (GetDistanceBetweenCoords(Impound.RetrieveLocation.X, Impound.RetrieveLocation.Y, Impound.RetrieveLocation.Z,
			PlayerPedCoords.x, PlayerPedCoords.y, PlayerPedCoords.z, false) < 3) then
				
				inZone = true
				
				if (CurrentAction ~= "retrieve") then
					
					CurrentAction = "retrieve"
					ESX.ShowHelpNotification(_U('take_out_vehicle'))
					
				end
				
			elseif (GetDistanceBetweenCoords(Impound.StoreLocation.X, Impound.StoreLocation.Y, Impound.StoreLocation.Z,
			PlayerPedCoords.x, PlayerPedCoords.y, PlayerPedCoords.z, false) < 3) then
				
				inZone = true
				
				if (CurrentAction ~= "store" and (PlayerData.job.name == "police" or PlayerData.job.name == "mecano")) then
					CurrentAction = "store"
					if (IsPedInAnyVehicle(PlayerPed)) then
						ESX.ShowHelpNotification(_U('leave_vehicle_for_impound'))
						return
					else
						if IsPedOnFoot(PlayerPed) and closestVehicle ~= 0 then
							ESX.ShowHelpNotification(_U('impound_vehicle'))
							return
						end
					end

				end
				
			else
				for i, location in ipairs(Impound.AdminTerminalLocations) do
					if (GetDistanceBetweenCoords(location.x, location.y, location.z,
					PlayerPedCoords.x, PlayerPedCoords.y, PlayerPedCoords.z, false) < 3) then
						
						inZone = true
						
						if (CurrentAction ~= "admin" and (PlayerData.job.name == "police" or PlayerData.job.name == "mecano")) then
							
							CurrentAction = "admin"
							ESX.ShowHelpNotification(_U('impound_terminal'))
						end
						
						break
					end
				end
			end
		end
		
		if not inZone then
			CurrentAction = nil
		end
	end
end)

Citizen.CreateThread(function ()
	
	while true do
		Citizen.Wait(0)
		if (IsControlJustReleased(0, 38)) then
			if (CurrentAction == "retrieve") then
				ShowRetrievalMenu()
			elseif (CurrentAction == "store") then
				ShowImpoundMenu("store")
			elseif (CurrentAction == "admin") then
				ShowAdminTerminal("admin")
			end
		end
	end
end)

-- Disable background actions if the player is currently in a menu
Citizen.CreateThread(function()
	while true do
		if GuiEnabled then
			local ply = PlayerPedId() 
			local active = true
			DisableControlAction(0, 1, active) -- LookLeftRight
			DisableControlAction(0, 2, active) -- LookUpDown
			DisableControlAction(0, 24, active) -- Attack
			DisablePlayerFiring(ply, true) -- Disable weapon firing
			DisableControlAction(0, 142, active) -- MeleeAttackAlternate
			DisableControlAction(0, 106, active) -- VehicleMouseControlOverride
			if IsDisabledControlJustReleased(0, 24) or IsDisabledControlJustReleased(0, 142) then -- MeleeAttackAlternate
				SendNUIMessage(
					{
						type = "click"
					}
				)
			end
		end
		Citizen.Wait(0)
	end
end)

function dump(o)
	if type(o) == 'table' then
		local s = '{ '
			for k,v in pairs(o) do
				if type(k) ~= 'number' then k = '"'..k..'"' end
				s = s .. '['..k..'] = ' .. dump(v) .. ','
			end
		return s .. '} '
	else
		return tostring(o)
	end
end